--
-- Valtra BP1709
-- Script Para Farming Simulator
-- Sandro Costa
-- @Data  10/01/2013

ValtraBP1709 = {};

source("dataS/scripts/vehicles/specializations/SetTurnedOnEvent.lua");

function ValtraBP1709.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;

function ValtraBP1709:load(xmlFile)
	self.updateSafeArea = SpecializationUtil.callSpecializationsFunction("updateSafeArea");

--Parte que faz peso na Plantadeira	
	self.extraWeights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.extraWeights#count"), 0);
    self.weights = {};
    for i=1, self.extraWeights do
        local weightnamei = string.format("vehicle.extraWeights.weight%d", i);
        self.weights[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, weightnamei .. "#index"));
        setVisibility(self.weights[i], false);
    end;
	
	self.currentWeight = 0;
	self.controlWeight = 0;
	self.singleWeight = 0;
	self.maxWeight = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.maxWeight#weight"), 7);
--At aqui	
	
	
--faz a plantadeira baixar
	local rotationPartNodeMiddle2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartMiddle2#index"));
    if rotationPartNodeMiddle2 ~= nil then
        self.rotationPartMiddle2 = {};
        self.rotationPartMiddle2.node = rotationPartNodeMiddle2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartMiddle2#minRot"));
        self.rotationPartMiddle2.minRot = {};
        self.rotationPartMiddle2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartMiddle2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartMiddle2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartMiddle2#maxRot"));
        self.rotationPartMiddle2.maxRot = {};
        self.rotationPartMiddle2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartMiddle2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartMiddle2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartMiddle2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartMiddle2#rotTime"), 2)*1000;
        self.rotationPartMiddle2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartMiddle2#touchRotLimit"), 10));
    end;
	
	local rotationPartNodeMiddle3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartMiddle3#index"));
    if rotationPartNodeMiddle3 ~= nil then
        self.rotationPartMiddle3 = {};
        self.rotationPartMiddle3.node = rotationPartNodeMiddle3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartMiddle3#minRot"));
        self.rotationPartMiddle3.minRot = {};
        self.rotationPartMiddle3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartMiddle3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartMiddle3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartMiddle3#maxRot"));
        self.rotationPartMiddle3.maxRot = {};
        self.rotationPartMiddle3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartMiddle3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartMiddle3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartMiddle3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartMiddle3#rotTime"), 2)*1000;
        self.rotationPartMiddle3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartMiddle3#touchRotLimit"), 10));
    end;
--at aqui

--toca um som na plantadeira	
	local airSeederPneumaticsound = getXMLString(xmlFile, "vehicle.airSeederPneumaticsound#file");
    if airSeederPneumaticsound ~= nil and airSeederPneumaticsound ~= "" then
		airSeederPneumaticsound = Utils.getFilename(airSeederPneumaticsound, self.baseDirectory);
        self.airSeederPneumaticsound = createSample("airSeederPneumaticsound");
        loadSample(self.airSeederPneumaticsound, airSeederPneumaticsound, false);
		self.airSeederPneumaticsoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.airSeederPneumaticsound#pitchOffset"), 1);
    end;
	

	local solitairRubbersound = getXMLString(xmlFile, "vehicle.solitairRubbersound#file");
    if solitairRubbersound ~= nil and solitairRubbersound ~= "" then
		solitairRubbersound = Utils.getFilename(solitairRubbersound, self.baseDirectory);
        self.solitairRubbersound = createSample("solitairRubbersound");
        loadSample(self.solitairRubbersound, solitairRubbersound, false);
		self.solitairRubbersoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.solitairRubbersound#pitchOffset"), 1);
    end;
--at aqui	
	
    self.aiTerrainDetailChannel1 = g_currentMission.cultivatorChannel;
    self.aiTerrainDetailChannel2 = g_currentMission.ploughChannel;
    self.plDireto = true;
    self.rocaSegura = false;
	self.isActive = false;
	self.downPosition = false;
	self.baixar = true;
	self.sowingBit = 0;
end;

function ValtraBP1709:delete()
end;

function ValtraBP1709:mouseEvent(posX, posY, isDown, isUp, button)
end;

function ValtraBP1709:keyEvent(unicode, sym, modifier, isDown)
	--if isDown and sym == Input.KEY_n then
		--self:setActive(not self.isActive);
		--self:setIsTurnedOn(not self.isTurnedOn);
	--end;
end;

function ValtraBP1709:update(dt)
self.time = self.time + dt;
--Adiciona o Peso
	    self.singleWeight = (self.maxWeight);
	

		if self.isTurnedOn and self.sowingBit == 0 then
				self.currentWeight = self.singleWeight;
				self.sowingBit = 1;
		end;
		
		if not self.isTurnedOn and self.sowingBit == 1 then
			if self.currentWeight >= self.maxWeight then
				self.currentWeight = 0;
				self.sowingBit = 0;
			end;
		end;
		
		if self.weights ~= nil then
			if self.emptyMass == nil then
				self.emptyMass = getMass(self.components[1].node);
				self.currentMass = self.emptyMass;
			end;
			local newMass = self.emptyMass + self.currentWeight;
			if newMass ~= self.currentMass then
				setMass(self.components[1].node, newMass);
				self.currentMass = newMass;
				for k,v in pairs(self.components) do
					if v.node == self.components[1].node then
						if v.centerOfMass ~= nil then
							setCenterOfMass(v.node, v.centerOfMass[1], v.centerOfMass[2], v.centerOfMass[3]);
						end;
						break;
					end;
				end;
			end;
		end;
		
--At aqui

--if self:getIsActiveForInput() then
	--if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
		--if self.fillLevel > 0 then
				--self.rotationMaxMiddle2 = not self.rotationMaxMiddle2;
		       -- self.rotationMaxMiddle3 = not self.rotationMaxMiddle3;
		--end;
	--end;
--end;
if self.attacherVehicle then

	if self.isTurnedOn then
		if self.baixar then
					self.rotationMaxMiddle2 = not self.rotationMaxMiddle2;
					self.rotationMaxMiddle3 = not self.rotationMaxMiddle3;
					self.translationMax = not self.translationMax;
						if self.attacherVehicle.isEntered then
						playSample(self.airSeederPneumaticsound, 1, 1, 0);
						end;
					self.baixar = false;
		end;
	else
		if not self.baixar then
					self.rotationMaxMiddle2 = not self.rotationMaxMiddle2;
					self.rotationMaxMiddle3 = not self.rotationMaxMiddle3;
					self.translationMax = not self.translationMax;
						if self.attacherVehicle.isEntered then
						playSample(self.airSeederPneumaticsound, 1, 1, 0);
						end;
					self.baixar = true;
		end;
	end;
end;


--baixa a plantadeira
			if self.rotationPartMiddle2 ~= nil then
				local x, y, z = getRotation(self.rotationPartMiddle2.node);
				local rot = {x,y,z};
				local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartMiddle2.maxRot, self.rotationPartMiddle2.minRot, 3, self.rotationPartMiddle2.rotTime, dt, not self.rotationMaxMiddle2);
				setRotation(self.rotationPartMiddle2.node, unpack(newRot));
			end;
			
	  self.downPosition = false;
			
	  if self.rotationPartMiddle2 ~= nil then
            local x, y, z = getRotation(self.rotationPartMiddle2.node);
            local maxRot = self.rotationPartMiddle2.maxRot;
            local eps = self.rotationPartMiddle2.touchRotLimit;

            if math.abs(x-maxRot[1]) < eps and math.abs(y-maxRot[2]) < eps and math.abs(z-maxRot[3]) < eps then
                self.downPosition = true;
            end;
        end;
			
			if self.rotationPartMiddle3 ~= nil then
				local x, y, z = getRotation(self.rotationPartMiddle3.node);
				local rot = {x,y,z};
				local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartMiddle3.maxRot, self.rotationPartMiddle3.minRot, 3, self.rotationPartMiddle3.rotTime, dt, not self.rotationMaxMiddle3);
				setRotation(self.rotationPartMiddle3.node, unpack(newRot));
			end;
--ate aqui
end;

function ValtraBP1709:draw()
end;

function ValtraBP1709:onDetach()
	self.sowingBit = 1;
	stopSample(self.solitairRubbersound);
	Utils.setEmittingState(self.threshingParticleSystems1, false);
end

function ValtraBP1709:updateSafeArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ)
end;